inboxen/tickets/urls.py
##
#    Copyright (C) 2014 Jessica Tallon & Matt Molyneaux
#
#    This file is part of Inboxen.
#
#    Inboxen is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Inboxen is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with Inboxen.  If not, see <http://www.gnu.org/licenses/>.
##

from django import urls

from inboxen.tickets import views

urlpatterns = [
    urls.re_path(
        r'^$',
        views.QuestionHomeView.as_view(),
        name='tickets-index'
    ),
    urls.re_path(
        r'^status/(?P<status>[!]?\w+)/$',
        views.QuestionListView.as_view(),
        name='tickets-list'
    ),
    urls.re_path(
        r'^status/(?P<status>[!]?\w+)/(?P<page>\d+)/$',
        views.QuestionListView.as_view(),
        name='tickets-list'
    ),
    urls.re_path(
        r'^ticket/(?P<pk>\d+)/$',
        views.QuestionDetailView.as_view(),
        name='tickets-detail'
    ),
]

inboxen/urls.py
##
#    Copyright (C) 2013 Jessica Tallon & Matt Molyneaux
#
#    This file is part of Inboxen.
#
#    Inboxen is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Inboxen is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with Inboxen.  If not, see <http://www.gnu.org/licenses/>.
##

from django import urls
from django.conf import settings
from django.conf.urls.static import static

from inboxen.views import attachment, email, error, home, i18n, index, manifest, stats, styleguide
from inboxen.views.inbox import add as inbox_add
from inboxen.views.inbox import edit as inbox_edit
from inboxen.views.inbox import inbox

handler400 = error.bad_request
handler403 = error.permission_denied
handler404 = error.not_found
handler500 = error.server_error


urlpatterns = [
    urls.re_path(r'^$', index.Index.as_view(), name='index'),
    urls.re_path(r'^manifest.json$', manifest.manifest, name='inboxen-manifest'),
    urls.re_path(r'^i18n.json$', i18n.i18n, name='inboxen-i18n'),

    urls.re_path(r'^stats/$', stats.stats, name='stats'),
    urls.re_path(r'^stats_recent.json$', stats.stats_recent, name='stats_recent'),

    # inbox add/edit views
    urls.re_path(r'^inbox/add/$', inbox_add.InboxAddView.as_view(), name='inbox-add'),
    urls.re_path(r'^inbox/edit/(?P<inbox>[a-zA-Z0-9\.]+)@(?P<domain>[a-zA-Z0-9\.]+)/$',
                 inbox_edit.InboxEditView.as_view(), name='inbox-edit'),
    urls.re_path(r'^inbox/delete/(?P<inbox>[a-zA-Z0-9\.]+)@(?P<domain>[a-zA-Z0-9\.]+)/$',
                 inbox_edit.InboxDisownView.as_view(), name='inbox-disown'),

    # email views
    urls.re_path(r'^inbox/attachment/(?P<attachmentid>\d+)/download/$',
                 attachment.AttachmentDownloadView.as_view(), name='email-attachment'),
    urls.re_path(r'^inbox/(?P<inbox>[a-zA-Z0-9\.]+)@(?P<domain>[a-zA-Z0-9\.]+)/email/(?P<id>[a-fA-F0-9]+)/$',
                 email.EmailView.as_view(), name='email-view'),
    urls.re_path(r'^inbox/(?P<inbox>[a-zA-Z0-9\.]+)@(?P<domain>[a-zA-Z0-9\.]+)/email/(?P<email>[a-fA-F0-9]+)/download/$',  # noqa: E501
                 attachment.download_email, name='download-email-view'),

    # inbox view
    urls.re_path(r'^inbox/(?P<inbox>[a-zA-Z0-9\.]+)@(?P<domain>[a-zA-Z0-9\.]+)/(?P<page>\d+)/$',
                 inbox.SingleInboxView.as_view(), name='single-inbox'),
    urls.re_path(r'^inbox/(?P<inbox>[a-zA-Z0-9\.]+)@(?P<domain>[a-zA-Z0-9\.]+)/$',
                 inbox.SingleInboxView.as_view(), name='single-inbox'),
    urls.re_path(r'^inbox/(?P<inbox>[a-zA-Z0-9\.]+)@(?P<domain>[a-zA-Z0-9\.]+)/search/(?P<q>.*)/$',
                 inbox.SingleInboxView.as_view(), name='single-inbox-search'),
    urls.re_path(r'^inbox/(?P<inbox>[a-zA-Z0-9\.]+)@(?P<domain>[a-zA-Z0-9\.]+)/search/$',
                 inbox.SingleInboxView.as_view(), name='single-inbox-search'),
    urls.re_path(r'^inbox/qr/(?P<inbox>[a-zA-Z0-9\.]+)@(?P<domain>[a-zA-Z0-9\.]+)/$',
                 inbox.qr, name='inbox-qrcode'),

    # unified inbox view
    urls.re_path(r'^inbox/(?P<page>\d+)/$', inbox.UnifiedInboxView.as_view(), name='unified-inbox'),
    urls.re_path(r'^inbox/$', inbox.UnifiedInboxView.as_view(), name='unified-inbox'),
    urls.re_path(r'^inbox/search/(?P<q>.*)/$', inbox.UnifiedInboxView.as_view(), name='unified-inbox-search'),
    urls.re_path(r'^inbox/search/$', inbox.UnifiedInboxView.as_view(), name='unified-inbox-search'),

    # form inlines
    urls.re_path(r'^forms/inbox/add/$', inbox_add.FormInboxAddView.as_view(), name='form-inbox-add'),
    urls.re_path(r'^forms/home/$', home.FormHomeView.as_view(), name='form-home'),
    urls.re_path(r'^forms/inbox/edit/(?P<inbox>[a-zA-Z0-9\.]+)@(?P<domain>[a-zA-Z0-9\.]+)/$',
                 inbox_edit.FormInboxEditView.as_view(), name='form-inbox-edit'),
    urls.re_path(r'^forms/inbox/email/$', inbox.FormInboxView.as_view(), name='form-inbox-email'),

    # user views
    urls.re_path(r'^user/home/(?P<page>\d+)/$', home.UserHomeView.as_view(), name='user-home'),
    urls.re_path(r'^user/home/$', home.UserHomeView.as_view(), name='user-home'),
    urls.re_path(r'^user/home/search/(?P<q>.*)/$', home.UserHomeView.as_view(), name='user-home-search'),
    urls.re_path(r'^user/home/search/$', home.UserHomeView.as_view(), name='user-home-search'),

    # other apps
    urls.re_path(r'^blog/', urls.include("inboxen.blog.urls")),
    urls.re_path(r'^click/', urls.include("inboxen.redirect.urls")),
    urls.re_path(r'^source/', urls.include("inboxen.source.urls")),
    urls.re_path(r'^user/account/', urls.include("inboxen.account.urls")),
    urls.re_path(r'^help/', urls.include("inboxen.cms.urls")),
    urls.re_path(r'^admin/', urls.include(("inboxen.cms.admin_urls", "cms"), namespace="admin")),
    urls.re_path(r'^user/', urls.include(("inboxen.search.urls", "search"), namespace="search")),
    urls.re_path(r'^monitor', urls.include(("inboxen.monitor.urls", "monitor"), namespace="monitor")),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += [
        urls.re_path(r'^styleguide$', styleguide.styleguide, name='inboxen-styleguide'),
        urls.re_path(r'^_csp_report/$', error.csp_report, name='csp_logger'),
    ]
    try:
        import debug_toolbar  # NOQA

        urlpatterns += [
            urls.re_path(r'^__debug__/', urls.include(debug_toolbar.urls)),
        ]
    except ImportError:
        pass

inboxen/tickets/models.py
##
#    Copyright (C) 2014 Jessica Tallon & Matt Molyneaux
#
#    This file is part of Inboxen.
#
#    Inboxen is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Inboxen is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with Inboxen.  If not, see <http://www.gnu.org/licenses/>.
##

from django.conf import settings
from django.db import models
from django.utils import safestring
from django.utils.translation import gettext_lazy as _
from lxml.html.clean import Cleaner
import markdown

from inboxen import validators
from inboxen.tickets import managers


class RenderBodyMixin(object):
    def render_body(self):
        if not self.body:
            return ""

        cleaner = Cleaner(
            allow_tags=["p", "a", "i", "b", "em", "strong", "ol", "ul", "li", "pre", "code"],
            safe_attrs=["href"],
            remove_unknown_tags=False,
            safe_attrs_only=True,
        )
        body = markdown.markdown(self.body)
        body = cleaner.clean_html(body)
        return safestring.mark_safe(body)


class Question(models.Model, RenderBodyMixin):
    # status contants
    NEW = 0
    IN_PROGRESS = 1
    NEED_INFO = 2
    RESOLVED = 3

    # status choices
    STATUS_CHOICES = (
        (NEW, _("New")),
        (IN_PROGRESS, _("In progress")),
        (NEED_INFO, _("Need more info")),
        (RESOLVED, _("Resolved")),
    )

    author = models.ForeignKey(settings.AUTH_USER_MODEL, null=True, on_delete=models.SET_NULL)
    date = models.DateTimeField(auto_now_add=True, db_index=True)
    last_modified = models.DateTimeField(auto_now=True)

    subject = models.CharField(max_length=512, validators=[validators.ProhibitNullCharactersValidator()])
    body = models.TextField(validators=[validators.ProhibitNullCharactersValidator()])

    status = models.SmallIntegerField(choices=STATUS_CHOICES, default=NEW, db_index=True)

    objects = managers.QuestionQuerySet.as_manager()

    @property
    def last_activity(self):
        """Return the lastest activity of this Question

        Expects the attribute "last_response_date" to be annotated
        """
        # TODO turn this property into an annotation
        if getattr(self, "last_response_date", None) is not None and self.last_response_date > self.last_modified:
            return self.last_response_date
        else:
            return self.last_modified

    def __str__(self):
        return u"%s from %s" % (self.subject, self.author)

    class Meta:
        ordering = ["-date"]


class Response(models.Model, RenderBodyMixin):
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    author = models.ForeignKey(settings.AUTH_USER_MODEL, null=True, on_delete=models.SET_NULL)
    date = models.DateTimeField(auto_now_add=True, db_index=True)

    body = models.TextField(validators=[validators.ProhibitNullCharactersValidator()])

    class Meta:
        ordering = ["date"]

    def __str__(self):
        return u"Response to %s from %s" % (self.question, self.author)

inboxen/tickets/views.py
##
#    Copyright (C) 2014 Jessica Tallon & Matt Molyneaux
#
#    This file is part of Inboxen.
#
#    Inboxen is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Inboxen is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with Inboxen.  If not, see <http://www.gnu.org/licenses/>.
##

from django.contrib.auth.mixins import LoginRequiredMixin
from django.db.models import Count, Max
from django.http import Http404, HttpResponseRedirect
from django.template.response import TemplateResponse
from django.urls import reverse
from django.views import generic

from inboxen.cms.decorators import is_secure_admin
from inboxen.cms.utils import app_reverse
from inboxen.tickets import forms, models


class FormMixin(generic.edit.FormMixin):
    """FormMixin specific to Tickets"""
    def get_context_data(self, **kwargs):
        kwargs = super(FormMixin, self).get_context_data(**kwargs)

        form_class = self.get_form_class()
        kwargs["form"] = self.get_form(form_class)

        return kwargs

    def post(self, request, *args, **kwargs):
        self.object_list = self.get_queryset()
        form_class = self.get_form_class()
        form = self.get_form(form_class)

        if form.is_valid():
            return self.form_valid(form)
        else:
            return self.form_invalid(form)

    def form_valid(self, form):
        form.save()
        return super(FormMixin, self).form_valid(form)


class QuestionHomeView(LoginRequiredMixin, generic.ListView, FormMixin):
    """List of questions that belong to current user"""
    paginate_by = 10
    model = models.Question
    form_class = forms.QuestionForm
    template_name = "tickets/question_home.html"

    def form_valid(self, form):
        self.object = form.save(commit=False)
        self.object.author = self.request.user

        return super(QuestionHomeView, self).form_valid(form)

    def get_context_data(self, **kwargs):
        context = super(QuestionHomeView, self).get_context_data(**kwargs)
        context["open"] = self.object_list.open()[:self.paginate_by]
        context["closed"] = self.object_list.closed()[:self.paginate_by]

        return context

    def get_queryset(self):
        qs = super(QuestionHomeView, self).get_queryset()
        qs = qs.filter(author=self.request.user).select_related("author")
        qs = qs.annotate(response_count=Count("response__id"), last_response_date=Max("response__date"))

        return qs

    def get_success_url(self):
        return app_reverse(self.request.page, "tickets-detail", kwargs={"pk": self.object.pk})


class QuestionListView(LoginRequiredMixin, generic.ListView):
    paginate_by = 25
    model = models.Question

    def get_context_data(self, **kwargs):
        context = super(QuestionListView, self).get_context_data(**kwargs)
        context["status"] = self.kwargs.get("status", "").title()

        return context

    def get_queryset(self):
        qs = super(QuestionListView, self).get_queryset()

        # filter statuses
        status = self.kwargs["status"].upper()
        if status == "OPEN":
            qs = qs.open()
        elif status == "CLOSED":
            qs = qs.closed()
        else:
            raise Http404

        qs = qs.filter(author=self.request.user).select_related("author")
        return qs.annotate(response_count=Count("response__id"), last_response_date=Max("response__date"))


class QuestionDetailView(LoginRequiredMixin, generic.DetailView, FormMixin):
    """View and respond to Question"""
    model = models.Question
    form_class = forms.ResponseForm

    def get_form_kwargs(self):
        kwargs = super(QuestionDetailView, self).get_form_kwargs()
        kwargs["author"] = self.request.user
        kwargs["question"] = self.object

        return kwargs

    def get_context_data(self, **kwargs):
        kwargs = super(QuestionDetailView, self).get_context_data(**kwargs)
        kwargs.setdefault("responses", self.get_responses())
        return kwargs

    def get_queryset(self):
        qs = super(QuestionDetailView, self).get_queryset()
        return qs.filter(author=self.request.user).select_related("author")

    def get_success_url(self):
        return app_reverse(self.request.page, "tickets-detail", kwargs={"pk": self.object.pk})

    def get_responses(self):
        return self.object.response_set.select_related("author").all()

    def post(self, *args, **kwargs):
        self.object = self.get_object()
        return super(QuestionDetailView, self).post(*args, **kwargs)


@is_secure_admin
def question_admin_index(request):
    questions = models.Question.objects.all()

    return TemplateResponse(
        request,
        "tickets/admin/index.html",
        {"questions": questions}
    )


@is_secure_admin
def question_admin_response(request, question_pk):
    try:
        question = models.Question.objects.get(pk=question_pk)
    except models.Question.DoesNotExist:
        raise Http404

    if request.method == "POST":
        form = forms.ResponseAdminForm(data=request.POST, question=question, author=request.user)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect(reverse("admin:tickets:index"))
    else:
        form = forms.ResponseAdminForm(question=question, author=request.user)

    context = {
        "form": form,
        "question": question,
        "responses": question.response_set.select_related("author").all(),
    }

    return TemplateResponse(
        request,
        "tickets/admin/response.html",
        context,
    )

inboxen/tickets/templates/tickets/new_question_email.html
<!DOCTYPE html>
<html lang="en-gb">
    <head>
        <meta http-equiv="Content-type" content="text/html; charset=UTF-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <meta name="referrer" content="strict-origin" />
    </head>
    <body>
        <p>Admins,</p>
        <p>{{ question.author }} has a question:</p>
        <p>Subject: {{ question.subject }}</p>
        <p>Link: <a href="{{ admin_url }}">{{ admin_url }}</a></p>
        <p>Message:</p>
        <p>{{ question.render_body }}</p>
</body>
</html>

inboxen/tickets/templates/tickets/question_detail.html
{# Copyright (c) 2015 Jessica Tallon & Matt Molyneaux. This file is part of Inboxen. Licensed under the terms of the GNU AGPL, as published by the FSF, version 3 the or later #}
{% extends 'inboxen/base.html' %}
{% load i18n bootstrap cms_tags inboxen_time %}

{% block headline %}{{ object.subject }}{% endblock %}

{% block breadcrumbs %}
    <ul class="breadcrumb">
        {% for pg in request.page.get_ancestors %}
            {% if not pg.is_root %}<li><a href="{{ pg.url }}">{{ pg.title }}</a></li>{% endif %}
        {% endfor %}
        <li><a href="{% app_url 'tickets-index' %}">{{ request.page.title }}</a></li>
        <li class="active">{{ object.subject }}</li>
    </ul>
{% endblock %}

{% block content %}
<p>
        <b>{% trans "Asked by" %}:</b> {{ object.author.username }}
    <br />
        <b>{% trans "Asked" %}:</b> <span title="{{ object.date|date:"r" }}">{{ object.date|inboxentime }}</span>
    <br />
        <b>{% trans "Last activity" %}:</b> <span title="{{ object.last_activity|date:"r" }}">{{ object.last_activity|inboxentime }}</span>
    <br />
        <b>{% trans "Status" %}:</b> {{ object.get_status_display }}
</p>
<p>{{ object.render_body }}</p>

<small><a href="#lastreply">{% trans "Latest reply" %} &raquo;</a><br />
<a href="#response-form">{% trans "Reply form" %} &raquo;</a></small>

<hr>
{% for response in responses %}
    <p {% if forloop.last %}id="lastreply"{% endif %}>{{ response.author.username }} {% trans "says" %}:</p>
    <p>{{ response.render_body }}</p>
    <hr>
{% endfor %}

<div class="col-xs-12 col-sm-8 col-sm-offset-2 col-md-6 col-md-offset-3 col-lg-4 col-lg-offset-4">
    <div class="panel panel-default">
        <div class="panel-body">
            <form id="response-form" class="form" method="post" action="{% app_url 'tickets-detail' pk=object.pk %}">
                {% csrf_token %}
                {{ form|bootstrap }}
                <button class="btn btn-primary">{% trans "Submit" %}</button>
            </form>
        </div>
    </div>
</div>
{% endblock %}

inboxen/tickets/templates/tickets/question_home.html
{# Copyright (c) 2015 Jessica Tallon & Matt Molyneaux. This file is part of Inboxen. Licensed under the terms of the GNU AGPL, as published by the FSF, version 3 the or later #}
{% extends 'inboxen/base.html' %}
{% load i18n bootstrap cms_tags %}

{% block headline %}{% trans "Tickets" %}{% endblock %}

{% block breadcrumbs %}
    <ul class="breadcrumb">
        {% for pg in request.page.get_ancestors %}
            {% if not pg.is_root %}<li><a href="{{ pg.url }}">{{ pg.title }}</a></li>{% endif %}
        {% endfor %}
        <li class="active">{{ request.page.title }}</li>
    </ul>
{% endblock %}

{% block content %}
{% app_url "tickets-list" status="open" as more_open_url %}
{% app_url "tickets-list" status="closed" as more_closed_url %}
<span class="sr-only"><a href="#question-form">{% trans "Go to Question form" %}</a></span>
<h3>{% trans "Open Questions" %}</h3>
{% include "tickets/includes/question_list.html" with questions=open more_url=more_open_url %}
<h3>{% trans "Resolved Questions" %}</h3>
{% include "tickets/includes/question_list.html" with questions=closed more_url=more_closed_url %}
<div class="col-xs-12 col-sm-8 col-sm-offset-2 col-md-6 col-md-offset-3 col-lg-4 col-lg-offset-4">
    <div class="panel panel-default">
        <div class="panel-heading">
            {% trans "Submit New Question" %}
        </div>
        <div class="panel-body">
            <form id="question-form" class="form" method="post" action="{% app_url 'tickets-index' %}">
                {% csrf_token %}
                {{ form|bootstrap }}
                <button class="btn btn-primary">{% trans "Submit" %}</button>
            </form>
        </div>
    </div>
</div>
{% endblock %}

inboxen/tickets/templates/tickets/question_list.html
{# Copyright (c) 2015 Jessica Tallon & Matt Molyneaux. This file is part of Inboxen. Licensed under the terms of the GNU AGPL, as published by the FSF, version 3 the or later #}
{% extends 'inboxen/base.html' %}
{% load i18n bootstrap cms_tags %}

{% block headline %}{% trans "Tickets" %}{% endblock %}

{% block breadcrumbs %}
    <ul class="breadcrumb">
        {% for pg in request.page.get_ancestors %}
            {% if not pg.is_root %}<li><a href="{{ pg.url }}">{{ pg.title }}</a></li>{% endif %}
        {% endfor %}
        <li><a href="{% app_url 'tickets-index' %}">{{ request.page.title }}</a></li>
        <li class="active">{% blocktrans trimmed %}Status: {{ status }}{% endblocktrans %}</li>
    </ul>
{% endblock %}

{% block content %}
{% include "tickets/includes/question_list.html" with questions=page_obj %}
{% if page_obj.has_previous or page_obj.has_next %}
<nav aria-labelledby="question-pager">
    <h2 id="question-pager" class="sr-only">{% trans "Question list navigation" %}</h2>
    <ul class="pager">
        {% if page_obj.has_previous %}
            <li class="previous"><a href="{% app_url 'tickets-list' status=status page=page_obj.previous_page_number %}">
                <span aria-hidden="true">&laquo;</span> {% trans "Previous" %}
            </a></li>
        {% endif %}
        {% if page_obj.has_next %}
            <li class="next"><a href="{% app_url 'tickets-list' status=status page=page_obj.next_page_number %}">
                {% trans "Next" %} <span aria-hidden="true">&raquo;</span>
            </a></li>
        {% endif %}
    </ul>
</nav>
{% endif %}
{% endblock %}